
function love.load(arg)
  if arg[#arg] == "-debug" then require("mobdebug").start() end
  Camera = require "camera"
  Blob = require "blob"
  require "colBoxes"
  blobs = {}
  
  -- Need to optimize probly, can't take much more than 50^2
  local length = 10
  
  for x = 1, length do
    for y = 1, length do
      blobs[(x-1)*length + (y)] = Blob(50 + x*20, 50 + y*20, 2)
    end
  end
  
  for i = 1, #blobs do
    --collisionBoxes[y][x]
  end
end

function love.update(dt)
  -- move
  for blob = 1, #blobs do
    blobs[blob]:update(dt)
    colBoxes.check(blobs[blob]) -- check wich collisionBox the blob is in
  end
  
  -- check collisions:
  for i = 1, #blobs do
    local curBlob = blobs[i]
    
    for j = i + 1, #blobs do
      otherBlob = blobs[j]
      if curBlob:collidesWith(otherBlob) then
        resolveCollision(curBlob, otherBlob)
      end
    end
  end
  
  -- clean table:
  local index = 1
  local backIndex = #blobs
  
  while index <= backIndex do
    -- remove all dead "from behind":
    if blobs[backIndex]:isDead() then 
      blobs[backIndex] = nil
    else -- if behindI points to last is alive
      while not blobs[index]:isDead() do -- go to first dead
        if index >= backIndex then -- break if gone too far
          break
        end
        index = index + 1
      end
      
      -- If behindI points to alive, I to dead, and the
      -- pointers haven't gone to far, switch them:
      if index < backIndex then
        blobs[index] = blobs[backIndex]
        blobs[backIndex] = nil
        index = index + 1
      end
    end
    
    backIndex = backIndex - 1
  end
end

function love.draw()
  for blob = 1, #blobs do
    blobs[blob]:draw()
  end
end

function resolveCollision(blob1, blob2)
  assert(Blob.isblob(blob1), "resolveCollisions: arg1: Arguments needs to be a Blob!")
  assert(Blob.isblob(blob2), "resolveCollisions: arg2: Arguments needs to be a Blob!")
  
  if blob1:getEnergy() > blob2:getEnergy() then
    blob2:kill()
  else
    blob1:kill()
  end
end
